         PRINT NOGEN
         BEGIN NAME=QDME,IBM=YES,TPFISOC=NO
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          (C) Copyright IBM Corp. 2005                               *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*   MODULE NAME = SEE BELOW                                           *
*                                                                     *
*        SOURCE MODULE NAME =  QDME (Pool driver)                     *
*                                                                     *
*        OBJECT MODULE NAME =  QDME                                   *
*                                                                     *
*        RELATED MODULE NAME =                                        *
*                                                                     *
*   DESCRIPTIVE NAME = SYSTEM DRIVER FOR zTPF                         *
*                                                                     *
*   STATUS = VERSION 5  MODIFICATION 1                                *
*                                                                     *
* FUNCTION=                                                           *
*                                                                     *
*  This segment edits the input msg.                                  *
***********************************************************************
         EJECT ,
***********************************************************************
*                                                                     *
*  ZTEST POOL TYPE  NUMBER  RETURN|NONE|DOUBLE  TOSS percentage       *
*  ZTEST POOL STATUS <ALL> <CLEAR>                                    *
*  ZTEST POOL ABORT x                                                 *
*                                                                     *
*  ZTEST POOL HELP                                                    *
*                                                                     *
*  Register and ECB conventions:  Marked in each subroutine where it  *
*  is deemed necessary due to code complexity.                        *
*  ECB Conventions:                                                   *
*                                                                     *
*  Name       Loc      Length      Use                                *
*  SAVEAREA   EBX000   32 bytes    Save R0-R7 across BPKDC            *
*  MACROEXP   EBX060   20 bytes    GETFC and RELFC expansions         *
*  BLKADDR    EBW000    4 bytes    CRETC places parameters here       *
*                                                                     *
*                                                                     *
*                                                                     *
*  Register Conventions: (This Subroutine only)                       *
*                                                                     *
*  R6  - DCTBPK base                                                  *
*  R7  - BPKDC branch index register                                  *
*                                                                     *
***********************************************************************
         CZ1CP                                                 DRV
         DCTSON
POOL0000 DS     0H
         L      R1,CE1CR0                 get block addr
         DCTBPK REG=R6                    DSECT INPUT PARAMETER LIST
         STM    R0,R7,SAVEAREA            SAVE REGISTERS ACROSS BPKDC
         BPKDC  EXECUTE=YES,BPKD=PARMBPK  PARSE THE I/P MESSAGE
         LM     R0,R7,SAVEAREA            RESTORE REGISTERS
         BACKC
***************************************************************
* BPKDC MACROS TO DEFINE THE LAYOUT OF A VALID INPUT MESSAGE.
***************************************************************
         SPACE 2
PARMBPK  BPKDC (PSR,POOLTYPE,TYPEBPP),                                 X
               (PDR,NUMBER,1,16),                                      X
               (KS,RETURN,1),(KS,DOUBLE,1),(KD,TOSS,1,4),              X
               (KD,MAXINT,1,4)
HELPBPK  BPKDC (PSR,POOLTYPE,TYPEBPP)
STATBPK  BPKDC (PSR,POOLTYPE,TYPEBPP),                                 X
               (KS,CLEAR,5),(KS,ALL,1)
ABRTBPK  BPKDC (PSR,POOLTYPE,TYPEBPP),                                 X
               (PDR,INTVALUE)
TYPEBPP  BPPSC (SST,3),(LST,3),(4ST,3),(SLT,3),(LLT,3),(4LT,3),(SDP,3),X
               (LDP,3),(4DP,3),(4D6,3),(HELP,1,HELPBPK),               X
               (STATUS,4,STATBPK),(ABORT,5,ABRTBPK)
**********************************************************************
* Assign meaningful names to BPKDC labels and ECB/DATA equates.      *
**********************************************************************
POOLTYPE EQU   BPKOPM1                 type of pool       
HOWMANY  EQU   BPKOPM2                 number of pools to get
CLEAR    EQU   BPKOPM2                 CLEAR option
ABORTIDX EQU   BPKOPM2                 ABORT Index
RETURN   EQU   BPKOPM3                 return  
STATALL  EQU   BPKOPM3                 STATUS ALL parm              
DOUBLE   EQU   BPKOPM4                 Double return         
PERCENT  EQU   BPKOPM5                 % to lose if used     
MAXIMUM  EQU   BPKOPM6                 Largest interval to use
SAVEAREA EQU   EBX000,32               R0-R7 save across BPKDC
FRWSAVE  EQU   EBX090,12               save info for double release
PARMADDR EQU   EBW000,4                params passed by CRETC
ESFACRET EQU   EBW012
RETFLAG  EQU   X'40'                   flag if returns asked for
NRETFLAG EQU   X'20'                   flag if no returns asked for
DUBLFLAG EQU   X'80'                   asked for a double return
         LTORG
         FINIS QDME
         END
