         PRINT NOGEN
***********************************************************************
*          Licensed Materials - Property of IBM                       *
*          "Restricted Materials of IBM"                              *
*          5748-T15                                                   *
*          Copyright IBM Corp. 2005, 2006                             *
*          All Rights Reserved                                        *
*          US Government Users Restricted Rights - Use, duplication   *
*          or disclosure restricted by GSA ADP Schedule Contract      *
*          with IBM Corp.                                             *
***********************************************************************
*  This file is provided on an "as is" basis.  There are no           *
*  warranties, express or implied, including the implied warranties   *
*  of merchantability and fitness for a particular purpose.           *
*  IBM has no obligation to provide service, defect correction, or    *
*  any maintenance for the file.  IBM has no obligation to supply     *
*  any updates or enhancements for the file to you even if such are   *
*  or later become available.                                         *
***********************************************************************
*  Change History                                                     *
*  D13928  01/26/06     Remove CMMZERO reference                      *
*                                                                     *
*                                                                     *
*                                                                     *
***********************************************************************
*                                                                     *
*  GENERAL INFORMATION:                                               *
*                                                                     *
*  Segment Name:  QDMB                                                *
*                                                                     *
*  Abstract:        POOL64 Driver                                     *
*                                                                     *
*  Description:                                                       *
*  POOL64 is able to run the system out of pools by cycling through   *
*  each directory of each valid pool type.  It can either return the  *
*  pools via a RELFC or 'lose' them.  The double return error path is *
*  also tested.  Also available is the ability to 'throw away' a      *
*  certain percentage of pools to simulate system losses.             *
*                                                                     *
***********************************************************************
*                                                                     *
RECTAB   DSECT
TABID    DS   H
TABSIZE  DS   H
         ORG   ,
PARMS    DSECT
BLOCK    DS   XL40
         ORG  BLOCK
FLAG     DS   F
RECID    DS   H
SIZE     DS   H
NUMBER   DS   F
THROW    DS   H
INTERVAL DS   F
OPTIONS  DS   X
DUMMY    DS   X
ROUTE    DS   XL3
DUMMY2   DS   X
CHECKDPT DS   X
POOLNAME DS   XL3
STATOPT  DS   X            STATUS OPTION
ALLSTAT  EQU  X'80'        DISPLAY ALL STATUS ENTRIES
DISP_CTL DS   X            DISPLAY CONTROL
STATSLOT DS   F            STATUS TABLE INDEX
STAT_ADDR DS  D            STATUS TABLE ADDRESS
         ORG   ,
STATTAB  DSECT
STATHEAD EQU  *
ITEMCNT  DS   F           NUMBER OF ITEMS IN TABLE
HEADLEN  EQU  *-STATHEAD
ITEMS    EQU  *
         ORG  STATHEAD    ORG TO 0 DISPLACEMENT
ITEM     EQU  *
PCOUNT   DS   F           DISPENSED POOL COUNT
PARMLEN  DS   H           LENGTH OF PARM TEXT
PARMTXT  DS   CL40
ISTAT    DS   X           ITEM STATUS
SDATE    DS   CL5         START DATE
STIME    DS   CL8         START TIME
EDATE    DS   CL5         END DATE
ETIME    DS   CL8         END TIME
FADDR    DS   CL8         FIRST ADDRESS DISPENSED
LADDR    DS   CL8         LAST ADDRESS DISPENSED
ITEMLEN  EQU  *-ITEM
MAXITEMS EQU  (FRAMECNT*FRAMESIZ-HEADLEN)/ITEMLEN
FRAMECNT EQU  1          NUMBER OF FRAMES USED
FRAMESIZ EQU  4095       FRAME SIZE
         ORG  ,
SAVEMSG  DSECT
MSGTEXT  DS   CL200      Saved msg text
BEG_TEXT EQU  21         beginning of text
MAXSCAN  EQU  30         max scan to look for func name
TRTAB    DS   XL256      tr table for EOM
         ORG  ,
         BEGIN NAME=QDMB,IBM=YES,AMODE=64,TPFISOC=NO
***********************************************************************
*                                                                     *
*   MODULE NAME = SEE BELOW                                           *
*                                                                     *
*        SOURCE MODULE NAME =  QDMB (Pool driver)                     *
*                                                                     *
*        OBJECT MODULE NAME =  QDMB                                   *
*                                                                     *
*        RELATED MODULE NAME =                                        *
*                                                                     *
*   DESCRIPTIVE NAME = SYSTEM DRIVER FOR zTPF                         *
*                                                                     *
*   STATUS = VERSION 5  MODIFICATION 1                                *
*                                                                     *
* FUNCTION=                                                           *
*                                                                     *
*  Pool is able to run the system out of pools by cycling through     *
*  each directory of each valid pool type.  It can either return the  *
*  pools via a RELFC or 'lose' them.  The double return error path is *
*  also tested.  Also available is the ability to 'throw away' a      *
*  certain percentage of pools to simulate system losses.             *
*                                                                     *
***********************************************************************
         EJECT ,
***********************************************************************
*                                                                     *
*  ZTEST PO64 TYPE  NUMBER  RETURN|NONE|DOUBLE  TOSS percentage       *
*  ZTEST PO64 STATUS <ALL> <CLEAR>                                    *
*  ZTEST PO64 ABORT x                                                 *
*                                                                     *
*  ZTEST PO64 HELP                                                    *
*                                                                     *
*  Register and ECB conventions:  Marked in each subroutine where it  *
*  is deemed necessary due to code complexity.                        *
*  ECB Conventions:                                                   *
*                                                                     *
*  Name       Loc      Length      Use                                *
*  SAVEAREA   EBX000   32 bytes    Save R0-R7 across BPKDC            *
*  MACROEXP   EBX060   20 bytes    GETFC and RELFC expansions         *
*  BLKADDR    EBW000    4 bytes    CRETC places parameters here       *
*                                                                     *
*                                                                     *
*                                                                     *
*  Register Conventions: (This Subroutine only)                       *
*                                                                     *
*  R6  - DCTBPK base                                                  *
*  R7  - BPKDC branch index register                                  *
*                                                                     *
***********************************************************************
         CZ1CP                                                 DRV
         DCTSON
POOL0000 DS     0H
         OI     CE1AII,CCE1CYC        mark ecb to survive cycle down
         OI     CE1AII,CCE1CRE        and children it creates
         LLGF   R1,CE1CR0                 get block addr                64MODE
         USING  PARMS,R1                  dsect
         CLC    FLAG,FROMCRET             was it a cret?
         JE     POOLCRET                  yes                           64MODE
         DROP   R1                        give up addressing
         GETCC  DF,L2                     get block to save im
U4       USING  SAVEMSG,R15
         LLGF   R15,CE1CRF                point to IM save block
         MVC    U4.MSGTEXT,0(R1)          Save IM to level 15
         DROP   U4
         DCTBPK REG=R6                    DSECT INPUT PARAMETER LIST
         ENTRC  QDMA                      Parse input msg
         LLGF   R6,CE1CR0                 GET BASE OF INPUT PARAM. LIST 64MODE
         GETCC D1,L1                  get a block for parameters
         LLGF  R5,CE1CR1              address parameter block           64MODE
         USING PARMS,R5               dsect block
         XC    BLOCK,BLOCK            clear it out
         LLGF   R7,POOLTYPE               INDEX VALUE OF GIVEN ACTION   64MODE
         B      POOL0100(R7)              BRANCH TO TABLE + INDEX VALUE
         SPACE  2
POOL0100 DS     0H                        BRANCH TABLE FOR EACH ACTION
         J      INVTYPE                   Invalid pool type error       64MODE
         J      POOL0SST                                                64MODE
         J      POOL0LST                                                64MODE
         J      POOL04ST                                                64MODE
         J      POOL0SLT                                                64MODE
         J      POOL0LLT                                                64MODE
         J      POOL04LT                                                64MODE
         J      POOL0SDP                                                64MODE
         J      POOL0LDP                                                64MODE
         J      POOL04DP                                                64MODE
         J      POOL04D6                                                64MODE
         J      HELPMSG                   give help                     64MODE
         J      STATUS000
         J      ABORT000
         EXITC                            incase we fall thru
         EJECT ,
***********************************************************************
* STATUS
***********************************************************************
STATUS000 DS 0H
U1       USING STATTAB,R7
         BRAS  R3,FIND_HEAP        Returns heap block in R7             64MODE
         LTGR  R7,R7               found ?                              64MODE
         JZ    NO_STATUS           no...
         LLGF  R5,U1.ITEMCNT          get item count                    64MODE
         LA    R7,U1.ITEMS            point to first item
         LGF   R15,CLEAR           get clear option                     64MODE
         LTGR  R15,R15             Is it a status clear request         64MODE
         JZ    DISPLAY             no..                                 64MODE
CLEAR_LOOP   DS   0H
         CLC   U1.EDATE,BLANKS     has it ended?
         JE    OPEN_STATS          no..                                 64MODE
         LA    R7,ITEMLEN(,R7)     bump ptr to next item
         BRCTG R5,CLEAR_LOOP
         LA    R7,POOLDRV_TOKEN    point to token name
         RSYSC TOKEN=R7            release SYSHEAP addr
         LA    R1,PMSG16           send end msg
         J     SUBMSG
OPEN_STATS   DS   0H
         LA    R1,PMSG17           send Some Instances not complete
         J     SUBMSG
DISPLAY  DS    0H
U3       USING PARMS,R15
         LLGF  R15,CE1CR1             address parameter block           64MODE
         NI    U3.STATOPT,X'FF'-ALLSTAT   INIT ALLSTAT IND
         LGF   R14,STATALL            STATUS ALL
         LTGR  R14,R14                Requested?                        64MODE
         JZ    STAT_ACTIVE            NO.just the active ones
         OI    U3.STATOPT,ALLSTAT     set to display all instances
STAT_ACTIVE    DS   0H
         SGR   R2,R2                  Clear instance count
         MVI   U3.DISP_CTL,X'00'      Clear display control
         WTOPC TEXT='PO64 Driver Status Display',LET=I,                X
               ENDOFM=NO,CHAIN=YES
ITEM_LOOP   DS   0H
         LA    R1,PMSG14
         AGHI  R2,1                   bump instance counter
         LLGF  R15,CE1CR1             address parameter block           64MODE
         TM    U3.STATOPT,ALLSTAT     Check status display option
         JO    DISP_ALL               Display all instance              64MODE
         CLC   U1.EDATE,BLANKS        Is instance active?
         JNE   SKIP_SLOT                                                64MODE
DISP_ALL    DS   0H
         MVI   U3.DISP_CTL,X'FF'
         WTOPC TEXTA=(R1),                                             X
               SUB=(DEC,(R2),                                          X
               CHARA,U1.PARMTXT,                                       X
               DECA,U1.PCOUNT,                                         X
               HEXBA,U1.FADDR,                                         X
               HEXBA,U1.LADDR,                                         X
               CHARA,U1.SDATE,                                         X
               CHARA,U1.STIME,                                         X
               CHARA,U1.EDATE,                                         X
               CHARA,U1.ETIME),                                        X
               HEADER=NO,CHAIN=YES,ENDOFM=NO
SKIP_SLOT   DS   0H
         LA    R7,ITEMLEN(,R7)
         BRCTG R5,ITEM_LOOP                                             64MODE
*
         LA    R1,PMSG24             Set default complet msg
         LLGF  R15,CE1CR1             address parameter block           64MODE
         CLI   U3.DISP_CTL,X'FF'     Did we display anything?
         JE    DISPLAYED             yep
         LA    R1,PMSG23             reset msg to Nothing to Display
DISPLAYED   DS   0H
         WTOPC TEXTA=(R1),LET=I,                                       X
               ENDOFM=YES,CHAIN=YES
         EXITC
         DROP  U1,U3
***********************************************************************
* ABORT
***********************************************************************
ABORT000 DS 0H
         LLGF  R4,ABORTIDX         Load addr of index value
         LLGF  R4,0(R4)            get index value                      64MODE
         BCTGR R4,0                decrement it for zero base           64MODE
         LTGR  R4,R4               test for negative                    64MODE
         JM    INDEX_INVALID       Jump if negative
ABORT_CONT2 DS 0H
U2       USING STATTAB,R7
         BRAS  R3,FIND_HEAP        Returns heap block in R7             64MODE
         LTGR  R7,R7               found ?                              64MODE
         JZ    NO_STATUS           no...
         LLGF  R5,U2.ITEMCNT       get item count                       64MODE
         BCTGR R5,0                                                     64MODE
         CGR   R4,R5                                                    64MODE
         JH    INDEX_INVALID
         LA    R7,U2.ITEMS         point to first item
         MGHI  R4,ITEMLEN          calc disp to item                    64MODE
         LA    R7,0(R4,R7)         set base of item
         CLC   U2.ETIME,BLANKS     Has instance already ended?
         JNE   NO_ABORT            yes..can't abort it
         CINFC W,CMMTPF,REG=R14    change to key 0                      D13928
         MVI   U2.ISTAT,X'FF'      set abort flag
         KEYRC                     reset protect key
         LA    R1,PMSG18           addr of abort request msg
         J     SUBMSG              send msg
INDEX_INVALID  DS 0H
         LA    R1,PMSG19           addr of invalid instance msg
         J     SUBMSG              send msg
NO_ABORT LA    R1,PMSG22           addr of Already Ended msg
         J     SUBMSG
         DROP  U2
***********************************************************************
* Determine subsystem and pool type specified.                        *
*                                                                     *
* REGS - R1 - name of SS inserted                                     *
*        R3 - UATBC macro usage                                       *
*        R4 - Scratch                                                 *
*        R5 - Base of parms block                                     *
*        R6 - Pool table absolute addr                                *
*        R7 - BPKDC index - used to build table index                 *
*        R15- branching                                               *
*                                                                     *
***********************************************************************
POOL0SST DS    0H
         MVC   POOLNAME,=C'SST'
         J     POOL0200                                                 64MODE
POOL0SLT DS    0H
         MVC   POOLNAME,=C'SLT'
         J     POOL0200                                                 64MODE
POOL0SDP DS    0H
         MVC   POOLNAME,=C'SDP'
         J     POOL0200                                                 64MODE
POOL0LST DS    0H
         MVC   POOLNAME,=C'LST'
         J     POOL0200                                                 64MODE
POOL0LLT DS    0H
         MVC   POOLNAME,=C'LLT'
         J     POOL0200                                                 64MODE
POOL0LDP DS    0H
         MVC   POOLNAME,=C'LDP'
         J     POOL0200                                                 64MODE
POOL04ST DS    0H
         MVC   POOLNAME,=C'4ST'
         J     POOL0200                                                 64MODE
POOL04LT DS    0H
         MVC   POOLNAME,=C'4LT'
         J     POOL0200                                                 64MODE
POOL04DP DS    0H
         MVC   POOLNAME,=C'4DP'
         J     POOL0200                                                 64MODE
POOL04D6 DS    0H
         MVC   POOLNAME,=C'4D6'
POOL0200 DS    0H
         UATBC IDLOC=(E,SSI,R3),NOTAVL=NOTACTV,NAME=R1
RWEBSS   DS    0H
         CLGF   R1,=C'BSS '           are we bss?                       64MODE
         JNE   RWEWP                  no                                64MODE
         LA    R15,BSSTAB             yes
         J     GET_RECID_AND_SIZE                                       hb1185
RWEWP    DS    0H
         CLGF   R1,=C'WP  '           are we wp?                        64MODE
         JNE   NOTACTV                no                                hb1185
         LA    R15,WPTAB              yes
         EJECT
***********************************************************************
* Get the record ID and size of the pool type if it exists.  If it    *
* does not exist then the size will be zero in the table.             *
***********************************************************************
GET_RECID_AND_SIZE DS    0H
         SGF   R7,FOUR                take 4 from index                 64MODE
         ALGR  R7,R15                 add offset to base offset         64MODE
         USING RECTAB,R7              dsect table
         CLC   TABSIZE,ZERO           no recid exist?
         JE    NONEDEF                yepper - this is bad              64MODE
         MVC   RECID,TABID            get record id to ecb
         WTOPC TEXT='Using Record ID : ....',SUB=(HEXBA,RECID),        X
               PREFIX=POOL,NUM=8,LET=I
         MVC   SIZE,TABSIZE           get size to ecb
         EJECT
***********************************************************************
* Get the number of dispenses desired and any flags like double       *
* return.  Note- double return will override the number parm with 1.  *
***********************************************************************
         LGF   R4,HOWMANY             get number to toss                64MODE
         LTGR  R4,R4                  is it zero?                       64MODE
         JZ    NONUMBR                yes - very bad                    64MODE
         LLGF  R4,0(R4)               justify R4                        64MODE
         ST    R4,NUMBER              save it
         MVC   ROUTE,EBROUT           save ebrout for WTOPCs
         LGF   R15,DOUBLE             get dr value                      64MODE
         LTGR  R15,R15                is it zero?                       64MODE
         JZ    POOL0310               yes                               64MODE
         CLI   1(R15),C'Y'            parm=DOUBLE?                      hb1185
         JE    POOL0305                yes ...                          64MODE
         J     PARMERR                 NODOUBLE not valid               hb1185
*         L     R4,ONE                 get a one
*         ST    R4,NUMBER              change number
POOL0305 DS    0H                                                       hb1185
         SGR   R4,R4                  zero R4                           64MODE
         STH   R4,THROW               toss = 0
         OI    OPTIONS,DUBLFLAG       set flag
         J     POOL0320               branch                            64MODE
POOL0310 DS    0H
         LGF   R4,RETURN                                                64MODE
         LTGR  R4,R4                  Do we want a return?              64MODE
         JZ    POOL0315               No ..                             hb1185
         CLI   1(R4),C'Y'             parm=RETURN?                      hb1185
         JE    POOL0320               yes ... return address            hb1185
         J     PARMERR                NORETURN NOT VALID                hb1185
POOL0315 DS    0H                                                       hb1185
         OI    OPTIONS,NRETFLAG       no - set no return flag
         EJECT
***********************************************************************
* Here we will get an optional maximum dispense interval.  If you     *
* dispense too many too fast, you will take a CTL-B1.  But you can    *
* set KUL higher.  If you set KUL high, you can specify an interval   *
* larger than 10.                                                     *
***********************************************************************
POOL0320 DS    0H
         LGF   R4,MAXIMUM             was MAX specified...              64MODE
         LTGR  R4,R4                  ??                                64MODE
         JZ    NOMAX                  no                                64MODE
         LLGF  R4,0(R4)               get max value                     64MODE
         CGF   R4,MAX                 max too high?                     64MODE
         JH    HIGHMAX                yes                               64MODE
         ST    R4,INTERVAL            save max
         J     GETTOSS                                                  64MODE
HIGHMAX  DS    0H
         LLGF  R4,MAX                 set max max                       64MODE
         ST    R4,INTERVAL            save it
         J     GETTOSS                                                  64MODE
NOMAX    DS    0H
         LLGF  R4,TEN                 set a small max                   64MODE
         ST    R4,INTERVAL            save it
         EJECT
***********************************************************************
* Here we will get an optional 'toss' level.  This parm means to toss *
* n-many pools per interval.  If the toss is 100 and the interval is  *
* 50 then all will be tossed.  (Toss means no return)  Toss can be no *
* higher than the max interval.                                       *
***********************************************************************
GETTOSS  DS    0H
         TM    OPTIONS,NRETFLAG
         JO    NOTOSS                                                   64MODE
         OI    OPTIONS,RETFLAG        set flag
         XC    THROW,THROW            clear toss parm
         LGF   R4,PERCENT             toss exist?                       64MODE
         LTGR  R4,R4                  well?                             64MODE
         JZ    NOTOSS                 NO                                64MODE
         LLGF  R4,0(R4)               get toss parm                     64MODE
         CGF   R4,MAX                 more than max interval?           64MODE
         JNH   TOSSOK                 NO                                64MODE
         LLGF  R4,MAX                 yes - reset                       64MODE
TOSSOK   DS    0H
         STH   R4,THROW               save it
NOTOSS   DS    0H
         DROP  R6
***********************************************************************
* Here is where we set up the instance status table in system heap    *
***********************************************************************
         BRAS  R3,FIND_HEAP        Returns heap block in R7             64MODE
         LTGR  R6,R7               found ?                              64MODE
         JNZ   FOUND_HEAP          yes
         LA    R6,POOLDRV_TOKEN    point to token name
         LGHI  R6,FRAMECNT         get 1 4K frame                       64MODE
         LA    R2,POOLDRV_TOKEN    point to token name
         GSYSC FRAMES=R6,TOKEN=R2,UNIQUE=YES,HEAP=64BIT
         LTGR  R6,R6                                                    64MODE
         JZ    FAIL_SYSHEAP
         USING STATTAB,R6
         CINFC W,CMMTPF,REG=R14    switch to key 0                      D13928
         XC    ITEMCNT,ITEMCNT     zero item count
         KEYRC
FOUND_HEAP  DS   0H
         CINFC W,CMMTPF,REG=R14    switch to key 0                      D13928
CSLOOP1     DS    0H
         LLGF  R14,ITEMCNT         GET COUNT
         LA    R15,1(,R14)         ADD ONE
         CGHI  R15,MAXITEMS        Room for another one?                64MODE
         JH    NO_ROOM             no...
         CS    R14,R15,ITEMCNT     serialize
         JNE   CSLOOP1             br if not done                       64MODE
         BCTGR R15,0               decrement for slot displ
         ST    R15,STATSLOT        save slot idx for cret
         LA    R6,ITEMS
         MGHI  R15,ITEMLEN         displ to avail slot                  64MODE
         LA    R6,0(R15,R6)        bump base to open slot
         GLOBZ REGR=R2
         LA    R5,STIME            get start time
         TIMEC
         MVC   SDATE,@U1DMT        get start date
         MVC   ETIME,BLANKS        blank end time
         TIMEC
         MVC   EDATE,BLANKS        blank end date
         DROP  R2
         XC    FADDR,FADDR         init First Address
         XC    LADDR,LADDR         init Last Address
         MVI   ISTAT,X'00'         clear item status
***********************************************************************
* We find the command parms in the saved msg block and move them to   *
* instance status                                                     *
***********************************************************************
U5       USING  SAVEMSG,R1
         LLGF  R1,CE1CRF           get saved im block addr
         AGHI  R1,BEG_TEXT         bump to msg text                     64MODE
         LA    R5,MAXSCAN          BYTES before we give up
FIND_FUNC   DS   0H
         CLC   POOL,0(R1)          Where is the function name
         JE    FOUND_FUNC          Found it                             64MODE
         AGHI  R1,1                Bump pointer                         64MODE
         BRCTG R5,FIND_FUNC                                             64MODE
         J     FAIL_FUNC_FIND                                           64MODE
FOUND_FUNC  DS    0H
         AGHI  R1,4                skip over func name                  64MODE
         LGR   R15,R1              Save location                        64MODE
         XC    U5.TRTAB,U5.TRTAB   clear tr table
         MVI   U5.TRTAB+#EOM,#EOM     set eom char for scan
         TRT   0(L'PARMTXT,R1),U5.TRTAB Find the EOM
         SGR   R1,R15              Calc length of parms                 64MODE
         CGHI  R1,L'PARMTXT        Too long?                            64MODE
         JL    MOVEPARMS           no..
         LGHI  R1,L'PARMTXT        Truncate                             64MODE
MOVEPARMS   DS   0H
         STH   R1,PARMLEN  Save parm length
         MVI   PARMTXT,C' '        Blank fisrt byte
         MVC   PARMTXT+1(L'PARMTXT-1),PARMTXT propagate blank
         BCTGR R1,0                decrement for EX                     64MODE
         EX    R1,MVCPARM          move parms
         XC    PCOUNT,PCOUNT       clear count
         KEYRC
         DROP  U5
***********************************************************************
* Time to kick off the CRET                                           *
***********************************************************************
         LLGF   R1,CE1CR0                 get block addr                64MODE
         LLGF   R5,CE1CR1                 get block addr                64MODE
         MVC   FLAG,FROMCRET          set flag
         LGR   R15,R5                 r15 is now parameter base         64MODE
         CRETC S,QDMB,STATE=1052,TIMEINC=1,LEVEL=D1
         J     CRETMSG
MVCPARM  MVC   PARMTXT(0),0(R15)
         DROP  R5
         DROP  R6
         DROP  R7
         EJECT ,
***********************************************************************
* Runtime section, gets pools ands CRETs to self.  Does ten at a time.*
*                                                                     *
* Register Usage:                                                     *
*     R1  - Base of passed parameters                                 *
*     R2  - Record id of target pool                                  *
*     R3  - Throttle and toss point                                   *
*     R4  - Number of pools to dispense this run                      *
*     R5  - Branching                                                 *
*     R7  - Total number of pools                                     *
*                                                                     *
***********************************************************************
POOLCRET DS    0H
         LLGF  R1,CE1CR0              get core block addr               64MODE
         USING PARMS,R1               dsect
***********************************************************************
* Here we find the instance status item using the index value passed  *
***********************************************************************
         USING STATTAB,R6
         LA    R6,POOLDRV_TOKEN        point to token name
         FSYSC TOKEN=R6                get SYSHEAP addr
         LTGR  R6,R6                   found ?                          64MODE
         JZ    FAIL_SYSHEAP            No..
         LLGF  R15,STATSLOT            get the right status slot index
         LA    R6,ITEMS
         MGHI  R15,ITEMLEN             displ to avail slot              64MODE
         LA    R6,0(R15,R6)            bump base to slot
         CLI   ISTAT,X'FF'             abort requested?
         JE    ABORT                   yes                              64MODE
         STG   R6,STAT_ADDR            store the status item address
         DROP  R6
*
         DECBC FUNC=CREATE,DECB=(R6),NAME=DECBNAME,ERROR=DECBERR
         IDECB REG=R6
         MVC   EBROUT,ROUTE            restore ebrout
         LGF   R4,NUMBER               effectively load count           64MODE
         LTGR  R4,R4                   is it zero?                      64MODE
         JZ    DONE                    yes - no more cretcs             64MODE
         SGR   R2,R2                   zero r2                          64MODE
         ICM   R2,B'0011',RECID        get recid
         CGF   R4,INTERVAL             is count more than interval?     64MODE
         JNH   POOL1000                no branch                        64MODE
         LLGF  R4,INTERVAL             force it to be interval          64MODE
         EJECT ,
***********************************************************************
*  This does the actual getting of pools/blocks and crets to itself   *
*  for as many as need be gotten.  We avoid errors by stoping and     *
*  letting the system post any ECBs it needs to.                      *
***********************************************************************
POOL1000 DS    0H
         SGR   R3,R3                   zero r3                          64MODE
         LGH   R3,THROW                load the percentage to toss      64MODE
         LLGF  R7,NUMBER               load old parameters              64MODE
         SGR   R7,R4                   effectively lower the count      64MODE
         ST    R7,NUMBER               save it
LOOP     DS    0H
         BRAS  R5,GETFCEXP             do the macro                     64MODE
         MVC   FRWSAVE,IDECFRW         save FARW for double release
         CLC   CHECKDPT,=C'd'          only want to check the pool
         JE    CHECKED                  type name for 1st dispense      64MODE
         ESFAC ,ADDR=IDECFA,ESFACRET   check to make sure the the
         LA    R7,ESFACRET             fileaddress dispensed comes
         USING SONFMT,R7               from the correct pool type, ie
         GRRTC RCC=SONPRCC,RETURN=(R14) if the user request 4dp, make
         IRCCR REG=R14                 sure the current file address
         LTGR  R14,R14                 is from 4dp                      64MODE
         JZ    GRRTC_FAIL                                               64MODE
         CLC   POOLNAME,IRCRPTN
         JNE   MISMATCH                                                 64MODE
         DROP  R7,R14
         MVC   CHECKDPT,=C'd'          indicate pool type check done
CHECKED  EQU   *
         CLC   IDECDLH,SIZE            gotten= asked?
         JNE   BADERR                  nope                             64MODE
         TM    OPTIONS,DUBLFLAG        double return?
         JNO   NO_DOUBLE_RELEASE       no                               64MODE
         RELFC DECB=(R6)               release new
         J     DOUBLE_RELEASE          go right to relfc d2 for error   64MODE
NO_DOUBLE_RELEASE DS    0H
         TM    OPTIONS,NRETFLAG        release on d2?
         JO    SKIP_RETURN             no                               64MODE
         CGR   R4,R3                   are we at the toss point?        64MODE
         JNH   SKIP_RETURN             yes                              64MODE
DOUBLE_RELEASE  DS    0H               double return branches here
         MVC   IDECFRW,FRWSAVE
         RELFC DECB=(R6)               release pool
SKIP_RETURN DS    0H
         BCTG  R4,LOOP                 loop around                      64MODE
         LGR   R15,R1                  parameters                       64MODE
         CRETC S,QDMB,STATE=1052,TIMEINC=1,LEVEL=D0   cret to myself
         EXITC      ***  E X I T   P O I N T  ***
ABORT    LA    R1,PMSG20
         WTOPC TEXTA=(R1),HEADER=NO
DONE     DS    0H
         LLGF  R1,CE1CR0              get core block addr               64MODE
***********************************************************************
* We update the instance status here                                  *
***********************************************************************
         USING STATTAB,R6
         LG    R6,STAT_ADDR            Load STAT item address
         GLOBZ REGR=R2
         CINFC W,CMMTPF,REG=R14        switch to key 0                  D13928
         LA    R5,ETIME                get end time
         TIMEC
         MVC   EDATE,@U1DMT            get end date
         KEYRC
         DROP  R2,R6
         CRUSA S0=1                    release the core block
         J     EXITMSG                 issue message and exit           64MODE
MISMATCH EQU   *
         LA    R1,PMSG21
         WTOPC TEXTA=(R1),HEADER=NO,                                   X
               SUB=(HEX,(R2),CHARA,POOLNAME),LET=E,CHAIN=NO,           X
               ENDOFM=YES
         EXITC
         EJECT ,
BADERR   DS    0H                      error service routine
         LA    R0,PMSG8
         SERRC E,ED0004,MSG,CP
*                  ***  E X I T    P O I N T  ***
GETFCEXP DS    0H
         IDECB REG=R6
         GETFC ,DECB=(R6),ID=(R2),BLOCK=YES macro expan to move to ecb
         RELCC DECB=(R6)
***********************************************************************
* Update the pool count in the instance status item                   *
***********************************************************************
         USING STATTAB,R14
         CINFC W,CMMTPF,REG=R14                                         D13928
         LG    R14,STAT_ADDR
         LLGF  R15,PCOUNT
         AGHI  R15,1
         ST    R15,PCOUNT
         OC    FADDR,FADDR            HAVE WE ALREADY SAVED FADDR
         JNZ   SAVE_LADDR
         MVC   FADDR,IDECFA           SAVE FIRST ADDR DISPENSED
SAVE_LADDR DS   0H
         MVC   LADDR,IDECFA           SAVE LAST ADDR DISPENSED
         DROP  R14,R6
BRBACK   BR    R5
***********************************************************************
* Subroutine to find the sysheap block                                *
***********************************************************************
FIND_HEAP DS   0H
         LA    R7,POOLDRV_TOKEN    point to token name
         FSYSC TOKEN=R7            get SYSHEAP addr
         BR    R3
***********************************************************************
* This section contains subroutines that issue an appropriate WTOPC   *
* and EXITC without any return.                                       *
***********************************************************************
FAIL_SYSHEAP DS 0H
         LA    R1,PMSG12
         J     SUBMSG
FAIL_FUNC_FIND DS 0H
         LA    R1,PMSG13
         J     SUBMSG
HELPMSG  DS    0H
         LA    R1,PMSG1              help message
         J     SUBMSG                                                   64MODE
INVTYPE  DS    0H
         LA    R1,PMSG2              pool type not recognized
         J     SUBMSG                                                   64MODE
NOTACTV  DS    0H
         LA    R1,PMSG3              subsystem invalid
         J     SUBMSG                                                   64MODE
NONEDEF  DS    0H
         LA    R1,PMSG4              no pools of that type exist
         J     SUBMSG                                                   64MODE
NONUMBR  DS    0H
         LA    R1,PMSG5              number is zero
         J     SUBMSG                                                   64MODE
CRETMSG  DS    0H
         LA    R1,PMSG6              CRET msg
         J     SUBMSG                                                   64MODE
EXITMSG  DS    0H
         LA    R1,PMSG7              driver exiting message
         J     SUBMSG                                                   64MODE
DECBERR  DS    0H
         LA    R1,PMSG9
         J     SUBMSG                                                   64MODE
PARMERR  DS    0H                    NORETURN/NODOUBLE not valid parms  hb1185
         LA    R1,PMSG11                                                hb1185
         J     SUBMSG                                                   hb1185
GRRTC_FAIL DS  0H
         LA    R1,PMSG10
         J     SUBMSG
NO_ROOM  DS 0H
         LA    R1,PMSG25             NO ROOM IN THE STATUS TABLE
         J     SUBMSG
NO_STATUS DS 0H
         LA    R1,PMSG15
SUBMSG   DS    0H
         WTOPC TEXTA=(R1),HEADER=NO
         CRUSA S0=2
         EXITC           *** E X I T   P O I N T ***
         EJECT ,
POOL     DC    C'PO64'
POOLDRV_TOKEN  DC   C'PO64DRVR'
DECBNAME DC    C'IPOOLTEST'
BLANKS   DC    C'        '
***********************************************************************
* All Data is stored here as well as the output messages given all    *
* through this sleigh ride.                                           *
***********************************************************************
ZERO     DC    F'0'                  constant 0
ONE      DC    F'1'                  constant 1
FOUR     DC    F'4'                  constant 4
TEN      DC    F'10'                 constant 10
MAX      DC    F'200'                constant 200
FROMCRET DC    C'CRET'               cret flag
BSSTAB   DC    C'Q1',X'017D',C'Q2',X'041F',C'Q3',X'0FFF'       ST
         DC    C'00',X'0000',C'00',X'0000',C'00',X'0000'       LT
         DC    C'PC',X'017D',C'PE',X'041F',C'QC',X'0FFF'       DP       hb1624
         DC    C'QG',X'0FFF'                                  4D6
WPTAB    DC    C'Q1',X'017D',C'Q2',X'041F',C'Q3',X'0FFF'       ST
         DC    C'QD',X'017D',C'QE',X'041F',C'QF',X'0FFF'       LT
         DC    C'PC',X'017D',C'PE',X'041F',C'QC',X'0FFF'       DP       hb1624
         DC    C'QG',X'0FFF'                                  4D6
***********************************************************************
*  Here are messages issued by WTOPC's.                               *
***********************************************************************
PMSG1    DC    AL1(PMSG1E-PMSG1S)
PMSG1S   DC    C'PO640001I ZTEST PO64 TYPE COUNT (Return) (Toss-x) '
         DC    C'(Maxint-y)'
         DC    AL1(#CAR)
         DC    C'PO640001I                       (Double) (Maxint-y)'
         DC    AL1(#CAR)
         DC    C'PO640001I ZTEST PO64 STATUS (ALL)(CLEAR)'
         DC    AL1(#CAR)
         DC    C'PO640001I ZTEST PO64 ABORT x'
PMSG1E   EQU   *
*
PMSG2    DC    AL1(PMSG2E-PMSG2S)
PMSG2S   DC    C'PO640002E Pool type invalid.  Use: '
         DC    C'SST, SLT, SDP, LST, LLT, LDP, 4ST, 4LT, 4DP, 4D6'
PMSG2E   EQU   *
*
PMSG3    DC    AL1(L'PMSG3S)
PMSG3S   DC    C'PO640003E Your subsystem is invalid'
*
PMSG4    DC    AL1(L'PMSG4S)
PMSG4S   DC    C'PO640004E No pools of that type exist in this SS'
*
PMSG5    DC    AL1(L'PMSG5S)
PMSG5S   DC    C'PO640005E You must specify a non-zero number'
*
PMSG6    DC    AL1(L'PMSG6S)
PMSG6S   DC    C'PO640006I Pool driver starting in 1 second'
*
PMSG7    DC    AL1(L'PMSG7S)
PMSG7S   DC    C'PO640007I Pool driver now ending.'
*
PMSG8    DC    AL1(PMSG8E-PMSG8S)
PMSG8S   DC    C'PO640008E Serious error encountered.'
         DC    AL1(#CAR),C' Record size mismatch.'
PMSG8E   EQU   *
PMSG9    DC    AL1(L'PMSG9S)
PMSG9S   DC    C'PO640009E Error creating DECB'
PMSG10   DC    AL1(L'PMSG10S)
PMSG10S  DC    C'PO640010E GRRTC Failed'
PMSG11   DC    AL1(L'PMSG11S)
PMSG11S  DC    C'PO640011E NODOUBLE and NORETURN are not valid parms.'
PMSG12   DC    AL1(L'PMSG12S)
PMSG12S  DC    C'PO640012F SYSHEAP FAILURE'
PMSG13   DC    AL1(L'PMSG13S)
PMSG13S  DC    C'PO640013E UNABLE TO PROCESS COMMAND'
PMSG14   DC    AL1(PMSG14E-PMSG14S)
PMSG14S  DC    AL1(#CAR)
         DC    C' Instance ..'
         DC    AL1(#CAR)
         DC    C'    Parms: ........................................ '
         DC    AL1(#CAR)
         DC    C'    Dispensed: ........ '
         DC    AL1(#CAR)
         DC    C'    First Addr: ................ '
         DC    AL1(#CAR)
         DC    C'    Last Addr:  ................ '
         DC    AL1(#CAR)
         DC    C'    Started: .....-........ '
         DC    AL1(#CAR)
         DC    C'    Stopped: .....-........ '
         DC    AL1(#CAR)
         DC    AL1(#CAR)
PMSG14E  EQU   *
PMSG15   DC    AL1(L'PMSG15S)
PMSG15S  DC    C'PO640015E No instances logged.'
PMSG16   DC    AL1(L'PMSG16S)
PMSG16S  DC    C'PO640016E Status cleared.'
PMSG17   DC    AL1(L'PMSG17S)
PMSG17S  DC    C'PO640017E Unable to clear. Instances still alive.'
PMSG18   DC    AL1(L'PMSG18S)
PMSG18S  DC    C'PO640018E Abort instance requested.'
PMSG19   DC    AL1(L'PMSG19S)
PMSG19S  DC    C'PO640019E Invalid instance entered.'
PMSG20   DC    AL1(L'PMSG20S)
PMSG20S  DC    C'PO640020I Instance aborted.'
PMSG21   DC    AL1(PMSG21E-PMSG21S)
PMSG21S  DC    C'PO640021E '
         DC    C'Dispensed pool type different than requested.'
         DC    AL1(#CAR)
         DC    C'Enter the following message and try again'
         DC    AL1(#CAR)
         DC    C'ZRTDM MODIFY RECID-....,RTP0-...A'
PMSG21E  EQU   *
PMSG22   DC    AL1(L'PMSG22S)
PMSG22S  DC    C'PO640022I Unable to abort. Instance already stopped.'
PMSG23   DC    AL1(L'PMSG23S)
PMSG23S  DC    C'No active instances to display.'
PMSG24   DC    AL1(L'PMSG24S)
PMSG24S  DC    C'Status display complete.'
PMSG25   DC    AL1(L'PMSG25S)
PMSG25S  DC    C'PO640025I Unable to start. Status table full.'
         EJECT
**********************************************************************
* Assign meaningful names to BPKDC labels and ECB/DATA equates.      *
**********************************************************************
POOLTYPE EQU   BPKOPM1                 type of pool           BPKOPM1
HOWMANY  EQU   BPKOPM2                 number of pools to get BPKOPM2
CLEAR    EQU   BPKOPM2
ABORTIDX EQU   BPKOPM2
RETURN   EQU   BPKOPM3                 return                 BPKOPM3
STATALL  EQU   BPKOPM3                 status all
DOUBLE   EQU   BPKOPM4                 Double return          BPKOPM4
PERCENT  EQU   BPKOPM5                 % to lose if used      BPKOPM5
MAXIMUM  EQU   BPKOPM6                 Largest interval to useBPKOPM6
SAVEAREA EQU   EBX000,64               R0-R7 save across BPKDC
FRWSAVE  EQU   EBX090,12               save info for double release
PARMADDR EQU   EBW000,4                params passed by CRETC
ESFACRET EQU   EBW012
RETFLAG  EQU   X'40'                   flag if returns asked for
NRETFLAG EQU   X'20'                   flag if no returns asked for
DUBLFLAG EQU   X'80'                   asked for a double return
         LTORG
         FINIS QDMB
         END
